
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Blue
#property indicator_color2 DimGray
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 DimGray
#property indicator_color6 LimeGreen
#property indicator_color7 LimeGreen
#define SIGNAL_BAR  0

extern int Nmbr_Bars = 120;
extern int Order = 3;
extern double Ecart = 1.61803399;
extern bool AlertPossible    = true;
extern bool AlertOnlySound   = false;
extern bool SoundBuy  = true;
extern bool SoundSell = true;
extern string Sound          = "alert2.wav";
extern bool SendMailPossible = false;

double G_ibuf_92[];
double G_ibuf_96[];
double G_ibuf_100[];
double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
double G_ibuf_116[];
double Gda_120[20][20];
double Gda_124[20];
double Gda_128[20];
double Gda_132[20];
int Gi_136;
int Gi_140;
int Gi_144;
int Gi_148;
int Gi_152;
int Gi_156;
int Gi_160;
double Gd_164;
double Gd_172;
double Gd_180;
double Gd_188;
double Gd_196;

int init() {
   Comment("MBFX System");
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, G_ibuf_92);
   SetIndexBuffer(1, G_ibuf_96);
   SetIndexBuffer(2, G_ibuf_100);
   SetIndexBuffer(3, G_ibuf_104);
   SetIndexBuffer(4, G_ibuf_108);
   SetIndexBuffer(5, G_ibuf_112);
   SetIndexBuffer(6, G_ibuf_116);
   return (0);
}

int deinit() {
   Comment("");
   ObjectDelete("REG");
   ObjectDelete("X1");
   ObjectDelete("X2");
   ObjectDelete("X3");
   ObjectDelete("Z1");
   ObjectDelete("Z2");
   ObjectDelete("Z3");
   return (0);
}

int start() {
   if (Year() >= 2020) return (0);
   datetime time_0 = 0;
   SetIndexDrawBegin(0, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(1, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(2, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(3, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(4, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(5, Bars - Nmbr_Bars - 1);
   SetIndexDrawBegin(6, Bars - Nmbr_Bars - 1);
   if (time_0 != Time[0]) {
      ObjectDelete("REG");
      ObjectDelete("X1");
      ObjectDelete("X2");
      ObjectDelete("X3");
      ObjectDelete("Z1");
      ObjectDelete("Z2");
      ObjectDelete("Z3");
      time_0 = Time[0];
   }
   Gi_152 = Order + 1;
   Gda_124[1] = Nmbr_Bars + 1;
   for (Gi_160 = 1; Gi_160 <= Gi_152 * 2 - 2; Gi_160++) {
      Gd_164 = 0;
      for (Gi_156 = 0; Gi_156 <= Nmbr_Bars; Gi_156++) Gd_164 += MathPow(Gi_156, Gi_160);
      Gda_124[Gi_160 + 1] = Gd_164;
   }
   for (Gi_160 = 1; Gi_160 <= Gi_152; Gi_160++) {
      Gd_164 = 0;
      for (Gi_156 = 0; Gi_156 <= Nmbr_Bars; Gi_156++) {
         if (Gi_160 == 1) Gd_164 += (High[Gi_156] + Low[Gi_156]) / 2.0;
         else Gd_164 += (High[Gi_156] + Low[Gi_156]) / 2.0 * MathPow(Gi_156, Gi_160 - 1);
      }
      Gda_128[Gi_160] = Gd_164;
   }
   for (Gi_140 = 1; Gi_140 <= Gi_152; Gi_140++) {
      for (Gi_136 = 1; Gi_136 <= Gi_152; Gi_136++) {
         Gi_144 = Gi_136 + Gi_140 - 1;
         Gda_120[Gi_136][Gi_140] = Gda_124[Gi_144];
      }
   }
   for (Gi_144 = 1; Gi_144 <= Gi_152 - 1; Gi_144++) {
      Gi_148 = 0;
      Gd_188 = 0;
      for (Gi_136 = Gi_144; Gi_136 <= Gi_152; Gi_136++) {
         if (MathAbs(Gda_120[Gi_136][Gi_144]) > Gd_188) {
            Gd_188 = MathAbs(Gda_120[Gi_136][Gi_144]);
            Gi_148 = Gi_136;
         }
      }
      if (Gi_148 == 0) return (0);
      if (Gi_148 != Gi_144) {
         for (Gi_140 = 1; Gi_140 <= Gi_152; Gi_140++) {
            Gd_196 = Gda_120[Gi_144][Gi_140];
            Gda_120[Gi_144][Gi_140] = Gda_120[Gi_148][Gi_140];
            Gda_120[Gi_148][Gi_140] = Gd_196;
         }
         Gd_196 = Gda_128[Gi_144];
         Gda_128[Gi_144] = Gda_128[Gi_148];
         Gda_128[Gi_148] = Gd_196;
      }
      for (Gi_136 = Gi_144 + 1; Gi_136 <= Gi_152; Gi_136++) {
         Gd_180 = Gda_120[Gi_136][Gi_144] / Gda_120[Gi_144][Gi_144];
         for (Gi_140 = 1; Gi_140 <= Gi_152; Gi_140++) {
            if (Gi_140 == Gi_144) Gda_120[Gi_136][Gi_140] = 0;
            else Gda_120[Gi_136][Gi_140] = Gda_120[Gi_136][Gi_140] - Gd_180 * Gda_120[Gi_144][Gi_140];
         }
         Gda_128[Gi_136] = Gda_128[Gi_136] - Gd_180 * Gda_128[Gi_144];
      }
   }
   Gda_132[Gi_152] = Gda_128[Gi_152] / Gda_120[Gi_152][Gi_152];
   for (Gi_136 = Gi_152 - 1; Gi_136 >= 1; Gi_136--) {
      Gd_196 = 0;
      for (Gi_140 = 1; Gi_140 <= Gi_152 - Gi_136; Gi_140++) {
         Gd_196 += (Gda_120[Gi_136][Gi_136 + Gi_140]) * (Gda_132[Gi_136 + Gi_140]);
         Gda_132[Gi_136] = 1 / Gda_120[Gi_136][Gi_136] * (Gda_128[Gi_136] - Gd_196);
      }
   }
   for (Gi_156 = 0; Gi_156 <= Nmbr_Bars; Gi_156++) {
      Gd_164 = 0;
      for (Gi_144 = 1; Gi_144 <= Order; Gi_144++) Gd_164 += (Gda_132[Gi_144 + 1]) * MathPow(Gi_156, Gi_144);
      G_ibuf_92[Gi_156] = Gda_132[1] + Gd_164;
   }
   Gd_172 = iStdDev(NULL, 0, Nmbr_Bars, 0, MODE_SMA, PRICE_HIGH, 0) * Ecart;
   for (Gi_156 = 0; Gi_156 <= Nmbr_Bars; Gi_156++) {
      G_ibuf_104[Gi_156] = G_ibuf_92[Gi_156] + Gd_172;
      G_ibuf_100[Gi_156] = G_ibuf_92[Gi_156] + (G_ibuf_104[Gi_156] - G_ibuf_92[Gi_156]) / 1.382;
      G_ibuf_96[Gi_156] = G_ibuf_92[Gi_156] + (G_ibuf_100[Gi_156] - G_ibuf_92[Gi_156]) / 1.618;
      G_ibuf_116[Gi_156] = G_ibuf_92[Gi_156] - Gd_172;
      G_ibuf_112[Gi_156] = G_ibuf_92[Gi_156] - (G_ibuf_92[Gi_156] - G_ibuf_116[Gi_156]) / 1.382;
      G_ibuf_108[Gi_156] = G_ibuf_92[Gi_156] - (G_ibuf_92[Gi_156] - G_ibuf_112[Gi_156]) / 1.618;
   }
   ObjectCreate("REG", OBJ_ARROW, 0, Time[0], G_ibuf_92[0]);
   ObjectSet("REG", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("REG", OBJPROP_COLOR, Blue);
   ObjectCreate("X1", OBJ_ARROW, 0, Time[0], G_ibuf_96[0]);
   ObjectSet("X1", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("X1", OBJPROP_COLOR, DimGray);
   ObjectCreate("X2", OBJ_ARROW, 0, Time[0], G_ibuf_100[0]);
   ObjectSet("X2", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("X2", OBJPROP_COLOR, Red);
   ObjectCreate("X3", OBJ_ARROW, 0, Time[0], G_ibuf_104[0]);
   ObjectSet("X3", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("X3", OBJPROP_COLOR, Red);
   ObjectCreate("Z1", OBJ_ARROW, 0, Time[0], G_ibuf_108[0]);
   ObjectSet("Z1", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("Z1", OBJPROP_COLOR, DimGray);
   ObjectCreate("Z2", OBJ_ARROW, 0, Time[0], G_ibuf_112[0]);
   ObjectSet("Z2", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("Z2", OBJPROP_COLOR, LimeGreen);
   ObjectCreate("Z3", OBJ_ARROW, 0, Time[0], G_ibuf_116[0]);
   ObjectSet("Z3", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   ObjectSet("Z3", OBJPROP_COLOR, LimeGreen);
  static int PrevSignal = 0, PrevTime = 0;

	  if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
	      return(0);

	  PrevTime = Time[0];

     if (AlertPossible == true) {
	 if(PrevSignal <= 0 && SoundBuy==true)
      {
        if((Close[SIGNAL_BAR +1] > G_ibuf_116[SIGNAL_BAR + 1] && Close[SIGNAL_BAR] < G_ibuf_116[SIGNAL_BAR])  > 0){
        if (AlertOnlySound) {PlaySound(Sound);} else 
          {
            PrevSignal = 1;
            Alert("MBFX System (", Symbol(), ", ", Period(), ")  -  BUY!!!");PlaySound(Sound);
            if (SendMailPossible) SendMail(Symbol()+ " M"+ Period()+ " MBFX System -  BUY!!!", "");
          }
      }
      }
    if(PrevSignal >= 0 && SoundSell == true)
      {
         if((Close[SIGNAL_BAR +1] < G_ibuf_104[SIGNAL_BAR + 1] && Close[SIGNAL_BAR] > G_ibuf_104[SIGNAL_BAR])  > 0){
        
        if (AlertOnlySound) {PlaySound(Sound);} else 
          {
            PrevSignal = -1;
            Alert("MBFX System(", Symbol(), ", ", Period(), ")  -  SELL!!!");PlaySound(Sound);
            if (SendMailPossible) SendMail(Symbol()+ " M"+ Period()+ " MBFX System  -  SELL!!!", "");
          }
      }
      }
      }
   return (0);
}